<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>Mouse Shadow</title>
</head>
<body>

  <div class="hero">
    <h1 contenteditable>🔥WOAH!</h1>
  </div>

  <style>
  html {
    color: black;
    font-family: sans-serif;
  }

  body {
    margin: 0;
  }

  .hero {
    min-height: 100vh;
    display: flex;
    justify-content: center;
    align-items: center;
    color: black;
  }

  h1 {
    text-shadow: 10px 10px 0 rgba(0,0,0,1);
    font-size: 100px;
  }
  </style>

<script>
  const hero = document.querySelector(".hero");
  const text = document.querySelector("h1");
  const walk = 100;

  function shadow(e) {
    const { offsetWidth: width, offsetHeight: height } = hero;
    let { offsetX: x, offsetY: y } = e;

    if (this !== e.target) {
      x += e.target.offsetLeft;
      y += e.target.offsetTop;
    }

    const xWalk = (x / width * walk) - (walk / 2);
    const yWalk = (y / height * walk) - (walk / 2);
    console.log(xWalk, yWalk);
    text.style.textShadow = `
      ${xWalk}px ${yWalk}px 0 blue,
      ${xWalk * -1}px ${yWalk}px 0 red,
      ${yWalk}px ${xWalk * -1}px 0 green,
      ${yWalk * -1}px ${xWalk}px 0 yellow
    `;
  }

  hero.addEventListener("mousemove", shadow);
</script>
</body>
</html>
